﻿using ComPDFKit.PDFDocument;
using ComPDFKitViewer.PdfViewer;
using PDF_Office.Model;
using Prism.Commands;
using Prism.Mvvm;
using Prism.Services.Dialogs;
using System;
using PDF_Office.Helper;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using PDF_Office.Model.HomePageToolsDialogs;
using ImTools;
using PDF_Office.Model.PageEdit;
using ComPDFKit.PDFPage;
using System.Threading.Tasks;
using System.Windows.Media.Imaging;
using System.Windows.Media;
using PDF_Office.CustomControl;

namespace PDF_Office.ViewModels.Dialog.HomePageToolsDialogs
{
    public class HomePageSplitDialogViewModel : BindableBase, IDialogAware
    {
        CPDFDocument document;

        private CPDFViewer currentViewer;

        private HomePageSplitDialogModel splitModel = new HomePageSplitDialogModel();

        private string savefilepath { get; set; }

        private string savefilename { get; set; }

        public DelegateCommand CancelCommand { get; set; }

        public DelegateCommand SplitCommand { get; set; }

        public DelegateCommand AveragePagesCommand { get; set; }

        public DelegateCommand AverageFilesCommand { get; set; }

        public DelegateCommand CustomPageRangeCommand { get; set; }

        public DelegateCommand FrontFileNameCommand { get; set; }

        public DelegateCommand FileNameLabelCommand { get; set; }

        public DelegateCommand FileNameDeimiterCommand { get; set; }

        public DelegateCommand FileNameDeimiterChangeCommand { get; set; }

        public DelegateCommand FileNameLabelChangeCommand { get; set; }

       

        private string pageRangeText = "0";
        public string PageRangeText
        {
            get { return pageRangeText; }
            set
            {
                pageRangeText = value;
            }
        }

        private string pageRangeSelectIndex = "0";
        public string PageRangeSelectIndex
        {
            get { return pageRangeSelectIndex; }
            set
            {
                pageRangeSelectIndex = value;
            }
        }

        private string averagePagesIsCheck = "True";
        public string AveragePagesIsCheck
        {
            get { return averagePagesIsCheck; }
            set
            {
                SetProperty(ref averagePagesIsCheck, value);
            }
        }

        private string averageFilesIsCheck = "False";
        public string AverageFilesIsCheck
        {
            get { return averageFilesIsCheck; }
            set
            {
                SetProperty(ref averageFilesIsCheck, value);
            }
        }

        private string customPageRangeIsCheck = "False";
        public string CustomPageRangeIsCheck
        {
            get { return customPageRangeIsCheck; }
            set
            {
                SetProperty(ref customPageRangeIsCheck, value);
            }
        }

        private string averagePagesIsEnabled = "True";
        public string AveragePagesIsEnabled
        {
            get { return averagePagesIsEnabled; }
            set
            {
                SetProperty(ref averagePagesIsEnabled, value);
            }
        }

        private string averageFilesIsEnabled = "False";
        public string AverageFilesIsEnabled
        {
            get { return averageFilesIsEnabled; }
            set
            {
                SetProperty(ref averageFilesIsEnabled, value);
            }
        }

        private string customPageRangeIsEnabled = "False";
        public string CustomPageRangeIsEnabled
        {
            get { return customPageRangeIsEnabled; }
            set
            {
                SetProperty(ref customPageRangeIsEnabled, value);
            }
        }

        private string averagePagesText = "";
        public string AveragePagesText
        {
            get { return averagePagesText; }
            set
            {
                averagePagesText = value;
            }
        }

        private string averageFilesText = "";
        public string AverageFilesText
        {
            get { return averageFilesText; }
            set
            {
                averageFilesText = value;
            }
        }

        private string filePathName = "";
        public string FilePathName
        {
            get { return filePathName; }
            set
            {
                SetProperty(ref filePathName, value);
            }
        }

        private string fileNameLabelText = "part";
        public string FileNameLabelText
        {
            get { return fileNameLabelText; }
            set
            {
                fileNameLabelText = value;
            }
        }

        private string fileNameDeimiterText = "-";
        public string FileNameDeimiterText
        {
            get { return fileNameDeimiterText; }
            set
            {
                fileNameDeimiterText = value;
            }
        }

        private string frontFileIsCheck = "True";
        public string FrontFileIsCheck
        {
            get { return frontFileIsCheck; }
            set
            {
                frontFileIsCheck = value;
            }
        }

        private string fileNameLabelIsCheck = "True";
        public string FileNameLabelIsCheck
        {
            get { return fileNameLabelIsCheck; }
            set
            {
                fileNameLabelIsCheck = value;
            }
        }

        private string fileNameDeimiterIsCheck = "True";
        public string FileNameDeimiterIsCheck
        {
            get { return fileNameDeimiterIsCheck; }
            set
            {
                fileNameDeimiterIsCheck = value;
            }
        }

        public HomePageSplitDialogViewModel()
        {
            CancelCommand = new DelegateCommand(cancel);
            SplitCommand = new DelegateCommand(split);
            AveragePagesCommand = new DelegateCommand(averagePages);
            AverageFilesCommand = new DelegateCommand(averageFiles);
            CustomPageRangeCommand = new DelegateCommand(customPageRange);
            FrontFileNameCommand = new DelegateCommand(frontFileName);
            FileNameLabelCommand = new DelegateCommand(fileNameLabel);
            FileNameDeimiterCommand = new DelegateCommand(fileNameDeimiter);
            FileNameDeimiterChangeCommand = new DelegateCommand(fileNameDeimiter);
            FileNameLabelChangeCommand= new DelegateCommand(fileNameLabel);
            

        }

        private void cancel()
        {
            RequestClose.Invoke(new DialogResult(ButtonResult.Cancel));
        }

        private void split()
        {
            HomePageEditHelper.GetPagerange(PageRangeSelectIndex, currentViewer, ref splitModel.PageRange, PageRangeText);

            if (FileNameDeimiterIsCheck == "True")
            {
                splitModel.FileNameDeimiter = FileNameDeimiterText;
            }
            else
            {
                splitModel.FileNameDeimiter = "";
            }

            if (FileNameDeimiterIsCheck == "True")
            {
                splitModel.FileNameDeimiter = FileNameDeimiterText;
            }
            else
            {
                splitModel.FileNameDeimiter = "";
            }
            if (FileNameLabelIsCheck == "True")
            {
                splitModel.FrontFileName = true;
            }
            else
            {
                splitModel.FrontFileName = false;
            }

            char[] enumerationSeparator = new char[] { ',' };
            char[] rangeSeparator = new char[] { '-' };
            if (!CommonHelper.GetPagesInRange(ref splitModel.PageParm, splitModel.PageRange, currentViewer.Document.PageCount, enumerationSeparator, rangeSeparator))
            { //TODO
                Trace.WriteLine("输入不对");
                return;
            }
            Trace.WriteLine("mmmmmmmmmmmmmmmmmmmmm---mmm"+splitModel.PageRange+"pppppp");
            if (splitModel.Mode == HomePageSplitDialogModel.SplitMode.AveragePages)
            {
                if (AveragePagesText != "") { 
                splitModel.GetModeCount = int.Parse(AveragePagesText);
                }
                int averagepagesremainder = 0;
                var averagepagesdocs = HomePageEditHelper.AverageSplitPages(currentViewer.Document.PageCount, splitModel.GetModeCount, ref averagepagesremainder);
                int averagepagesdoc;
                for (averagepagesdoc = 1; averagepagesdoc < averagepagesdocs; averagepagesdoc++) {
                    CPDFDocument extractdoc = CPDFDocument.CreateDocument();
                    extractdoc.ImportPages(currentViewer.Document, (1 + splitModel.GetModeCount * (averagepagesdoc - 1)).ToString() + "-" + (splitModel.GetModeCount * averagepagesdoc).ToString());
                    if (splitModel.FrontFileName)
                    {
                        extractdoc.WriteToFilePath(savefilepath + splitModel.FileNameDeimiter + splitModel.FileNameLabel + averagepagesdoc.ToString() + ".pdf");
                    }
                    else {
                        extractdoc.WriteToFilePath(currentViewer.Document.FilePath + splitModel.FileNameLabel + splitModel.FileNameDeimiter + currentViewer.Document.FileName + averagepagesdoc.ToString() + ".pdf");

                    }
                    extractdoc.Release();
                }
                if (averagepagesdoc == averagepagesdocs) {
                    CPDFDocument extractdoc = CPDFDocument.CreateDocument();
                    extractdoc.ImportPages(currentViewer.Document, (1 + splitModel.GetModeCount * (averagepagesdoc - 1)).ToString() + "-" + currentViewer.Document.PageCount.ToString());
                    if (splitModel.FrontFileName)
                    {
                        extractdoc.WriteToFilePath(savefilepath + splitModel.FileNameDeimiter + splitModel.FileNameLabel + averagepagesdoc.ToString() + ".pdf");
                    }
                    else
                    {
                        extractdoc.WriteToFilePath(currentViewer.Document.FilePath + splitModel.FileNameLabel + splitModel.FileNameDeimiter + currentViewer.Document.FileName + averagepagesdoc.ToString() + ".pdf");

                    }
                }
            }
            if (splitModel.Mode == HomePageSplitDialogModel.SplitMode.AverageFiles)
            {
                if (AverageFilesText != "")
                {
                    splitModel.GetModeCount = int.Parse(AverageFilesText);
                }
                int averagefilesremainder = 0;
                var averagefilespages = HomePageEditHelper.AverageSplitDocs(currentViewer.Document.PageCount, splitModel.GetModeCount, ref averagefilesremainder);
                int averagefilesdoc;
                if (splitModel.GetModeCount > currentViewer.Document.PageCount)
                { splitModel.GetModeCount = 10; }
                for (averagefilesdoc = 1; averagefilesdoc <= splitModel.GetModeCount; averagefilesdoc++) {
                    CPDFDocument extractdoc = CPDFDocument.CreateDocument();
                    if (averagefilesremainder > 0) {
                        extractdoc.ImportPages(currentViewer.Document, (1 + (averagefilespages + 1) * (averagefilesdoc - 1)).ToString() + "-" + ((averagefilespages + 1) * averagefilesdoc).ToString());
                        Trace.WriteLine("gggggggggggggg" + (1 + (averagefilespages + 1) * (averagefilesdoc - 1)).ToString() + "-" + ((averagefilespages + 1) * averagefilesdoc).ToString());
                        extractdoc.WriteToFilePath(savefilepath + splitModel.FileNameDeimiter + splitModel.FileNameLabel + averagefilesdoc.ToString() + ".pdf");
                        averagefilesremainder--;
                    }
                    else {
                        extractdoc.ImportPages(currentViewer.Document, (averagefilespages * averagefilesremainder + averagefilesremainder + 1 + averagefilespages * (averagefilesdoc - 1)).ToString() + "-" + (averagefilespages * averagefilesremainder + averagefilesremainder + (averagefilespages * averagefilesdoc)).ToString());
                        Trace.WriteLine("gggggggggggggg" + (averagefilespages * averagefilesremainder + averagefilesremainder + 1 + averagefilespages * (averagefilesdoc - 1)).ToString() + "-" + (averagefilespages * averagefilesremainder + averagefilesremainder + (averagefilespages * averagefilesdoc)).ToString());
                        extractdoc.WriteToFilePath(savefilepath + splitModel.FileNameDeimiter + splitModel.FileNameLabel + averagefilesdoc.ToString() + ".pdf");
                    }
                    
                    extractdoc.Release();
                }

            }
            if (splitModel.Mode == HomePageSplitDialogModel.SplitMode.CustomPageRange)
            {

                CPDFDocument extractdoc = CPDFDocument.CreateDocument();
                extractdoc.ImportPages(currentViewer.Document, splitModel.PageRange);
                extractdoc.WriteToFilePath(savefilepath + splitModel.FileNameDeimiter + splitModel.FileNameLabel + "1" + ".pdf");
                currentViewer.Document.RemovePages(splitModel.PageParm.ToArray());
                currentViewer.Document.WriteToFilePath(savefilepath + splitModel.FileNameDeimiter + splitModel.FileNameLabel + "2" + ".pdf");

            }
            System.Diagnostics.Process.Start("Explorer", "/select," + currentViewer.Document.FilePath);
            RequestClose.Invoke(new DialogResult(ButtonResult.OK));
        }

        private void averagePages() {
            CustomPageRangeIsCheck = "False";
            AverageFilesIsCheck = "False";
            AveragePagesIsCheck = "True";

            CustomPageRangeIsEnabled = "False";
            AverageFilesIsEnabled = "False";
            AveragePagesIsEnabled = "True";
            splitModel.Mode = HomePageSplitDialogModel.SplitMode.AveragePages;

        }

        private void averageFiles() {
            CustomPageRangeIsCheck = "False";
            AverageFilesIsCheck = "True";
            AveragePagesIsCheck = "False";

            CustomPageRangeIsEnabled = "False";
            AverageFilesIsEnabled = "True";
            AveragePagesIsEnabled = "False";
            splitModel.Mode = HomePageSplitDialogModel.SplitMode.AverageFiles;

        }

        private void customPageRange() {
            CustomPageRangeIsCheck = "True";
            AverageFilesIsCheck = "False";
            AveragePagesIsCheck = "False";

            CustomPageRangeIsEnabled = "True";
            AverageFilesIsEnabled = "False";
            AveragePagesIsEnabled = "False";
            splitModel.Mode = HomePageSplitDialogModel.SplitMode.CustomPageRange;

        }

        private void frontFileName() {
            if (FrontFileIsCheck == "True")
            {
                FilePathName = savefilename + FileNameDeimiterText + FileNameLabelText;
                splitModel.FrontFileName = true;
            }
            else { 
                splitModel.FrontFileName=false;
                FilePathName = FileNameLabelText + FileNameDeimiterText + savefilename;
            }
            
        }

        private void fileNameLabel() {
            if (FileNameLabelIsCheck == "True")
            {
                if (FrontFileIsCheck == "True")
                {
                    FilePathName = savefilename + FileNameDeimiterText + FileNameLabelText;
                    splitModel.FrontFileName = true;
                }
                else
                {
                    splitModel.FrontFileName = false;
                    FilePathName = FileNameLabelText + FileNameDeimiterText + savefilename;
                }
            }
            else {
                
                if (FrontFileIsCheck == "True")
                {
                    FilePathName = savefilename + FileNameDeimiterText + FileNameLabelText;
                    splitModel.FrontFileName = true;
                }
                else
                {
                    splitModel.FrontFileName = false;
                    FilePathName = FileNameLabelText + FileNameDeimiterText + savefilename;
                }
            }
        
        }

        private void fileNameDeimiter() {
            if (FileNameDeimiterIsCheck == "True")
            {
                if (FrontFileIsCheck == "True")
                {
                    FilePathName = savefilename + FileNameDeimiterText + FileNameLabelText;
                    
                }
                else
                {
                    
                    FilePathName = FileNameLabelText + FileNameDeimiterText + savefilename;
                }
            }
            else
            {
                
                if (FrontFileIsCheck == "True")
                {
                    FilePathName = savefilename + FileNameDeimiterText + FileNameLabelText;
                    
                }
                else
                {
                    
                    FilePathName = FileNameLabelText + FileNameDeimiterText + savefilename;
                }
            }

        }

       
        public string Title =>"";

        public event Action<IDialogResult> RequestClose;

        public bool CanCloseDialog()
        {
            return true;
        }

        public void OnDialogClosed()
        {

        }

        public void OnDialogOpened(IDialogParameters parameters)
        {
            CPDFViewer viewer = null;
            string filepath = "";
            parameters.TryGetValue<CPDFViewer>(ParameterNames.PDFViewer, out viewer);
            parameters.TryGetValue<string>(ParameterNames.FilePath, out filepath);
            if (viewer != null && viewer.Document != null)
            {
                currentViewer = viewer;
                savefilepath = filepath;
                savefilename = currentViewer.Document.FileName;
                
            }
        }
    }
}
